// barsunduk 06,11/2011
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;

public class Lib_spr {

    public final static int trans_none = 0;
    public final static int trans_mirror = 2;
    public final static int trans_rot90 = 5;
    public final static int trans_rot180 = 3;
    public final static int trans_rot270 = 6;
    public final static int trans_mirror_rot90 = 7;
    public final static int trans_mirror_rot180 = 1;
    public final static int trans_mirror_rot270 = 4;

    public final static int p_align = 0; //   (0-/1- /2-  / ..  )
    public final static int p_x = 1; //   
    public final static int p_y = 2; //   
    public final static int p_w = 3; //  
    public final static int p_h = 4; //  
    public final static int p_layer = 5; //    ()
    public final static int p_step = 6; //    
    public final static int p_frame = 7; //    
    public final static int p_row = 8; //    
    public final static int p_trans = 9; //  (/)
    public final static int p_img = 10; //  
    public final static int p_enable = 11; // 
    public final static int p_visible = 12; // 
    public final static int p_fplus = 13; //   
    public final static int p_rplus = 14; //   
    public final static int p_frameback = 15; //       

    private final static int parcount = 16; //   
    
    private static int Fminalpha = 0; //     
    //  Fminalpha = 0       
    //  Fminalpha = 255       

    private static int[][] p = null; //    [sprIndex][paramIndex]
    private static Image[] png = null; //     

    private static int sprcount = 0; //   
    private static int curspr = 0; //   
    private static int maxcount = 512; //    
    private static int curimg = 0; //   

    //       [0..255]
    public static int getminalpha() {
        return Fminalpha;
    }

    //       [0..255]
    public static void setminalpha(int minalpha) {
        minalpha = (minalpha < 0) ? 0 : minalpha;
        minalpha = (minalpha > 255) ? 255 : minalpha;
        Fminalpha = minalpha;
    }

    //      1 
    public static Image empty() {
        return Image.createImage(1, 1);
    }
    
    //     
    public static int ptinrect(int x, int y, int rx, int ry, int rw, int rh) {
        if((x >= rx)&&(y >= ry)&&(x < rx + rw)&&(y < ry + rh)) {
            return 1;
        } else return 0;
    }

    //   
    public static int xrect(int rx1, int ry1, int rw1, int rh1,
            int rx2, int ry2, int rw2, int rh2) {
        return (ptinrect(rx1, ry1, rx2, ry2, rw2, rh2) |
                ptinrect(rx1 + rw1, ry1, rx2, ry2, rw2, rh2) |
                ptinrect(rx1 + rw1, ry1 + rh1, rx2, ry2, rw2, rh2) |
                ptinrect(rx1, ry1 + rh1, rx2, ry2, rw2, rh2) |
                ptinrect(rx2, ry2, rx1, ry1, rw1, rh1) |
                ptinrect(rx2 + rw2, ry2, rx1, ry1, rw1, rh1) |
                ptinrect(rx2 + rw2, ry2 + rh2, rx1, ry1, rw1, rh1) |
                ptinrect(rx2, ry2 + rh2, rx1, ry1, rw1, rh1));
    }

    //     
    public static int sprxrect(int spr, int x, int y, int w, int h) {
        return xrect(getx0(spr), gety0(spr), getw(spr), geth(spr), x, y, w, h);
    }
    
    //    
    public static int get(int sprindex, int parindex) {
        int res = -1;
        if ((parindex >= 0)&&(parindex < parcount)&&(sprindex >= 0)&&(sprindex < sprcount)) {
            res = p[sprindex][parindex];
        }
        return res;
    }

    //    
    public static void set(int sprindex, int parindex, int value) {
        if ((parindex >= 0)&&(parindex < parcount)&&(sprindex >= 0)&&(sprindex < sprcount)) {
            p[sprindex][parindex] = value;
        }
    }

    //    
    //    0,   ,   ,
    //       
    public static void initspr(int spr_count) {
        sprcount = spr_count;
        if ((sprcount <= 0)||(sprcount > maxcount)) {
            p = null;
            png = null;
        } else {
            p = new int[sprcount][parcount];
            png = new Image[sprcount];
            for(int is = 0; is < sprcount; is++) {
                for(int ip = 0; ip < parcount; ip++)
                    p[is][ip] = 0;
                p[is][p_img] = -1;
            }
        }
        curspr = -1;
        curimg = -1;
    }

    //      
    public static void seti(Image img, int imgindex) {
        if ((imgindex >= 0)&&(imgindex < curspr)) {
            png[imgindex] = img;
        }
    }

    // / 
    // (    )
    public static int getalign(int sprindex) {
        return get(sprindex, p_align);
    }
    
    // 0 -   , 1 -  , 2 -   ,
    // 3 -  , 4 -     ..
    public static void setalign(int sprindex, int value) {
        value %= 8;
        value = (value < 0) ? 8 - value : value;
        set(sprindex, p_align, value);
    }
    
    public static int getx(int sprindex) {
        return get(sprindex, p_x);
    }

    public static void setx(int sprindex, int value) {
        set(sprindex, p_x, value);
    }

    public static int gety(int sprindex) {
        return get(sprindex, p_y);
    }

    public static void sety(int sprindex, int value) {
        set(sprindex, p_y, value);
    }

    public static int getw(int sprindex) {
        return get(sprindex, p_w);
    }

    public static void setw(int sprindex, int value) {
        set(sprindex, p_w, value);
    }

    public static int geth(int sprindex) {
        return get(sprindex, p_h);
    }

    public static void seth(int sprindex, int value) {
        set(sprindex, p_h, value);
    }

    public static int getlayer(int sprindex) {
        return get(sprindex, p_layer);
    }

    public static void setlayer(int sprindex, int value) {
        if((value < 0)||(value > curspr)){
            value = getlayer(sprindex);
        }
        set(sprindex, p_layer, value);
    }

    public static int getstep(int sprindex) {
        return get(sprindex, p_step);
    }

    public static void setstep(int sprindex, int value) {
        set(sprindex, p_step, value);
    }

    public static int getframe(int sprindex) {
        return get(sprindex, p_frame);
    }

    public static int getframes(int sprindex) {
        if (get(sprindex, p_img) >= 0) {
    	    return png[get(sprindex, p_img)].getWidth() / get(sprindex, p_w);
        } else {
            return -1;
        }
    }

     public static void setframe(int sprindex, int value) {
     	if ((value >= 0)&&(value < getframes(sprindex))) {
            set(sprindex, p_frame, value);
        }
    }

    public static int getrows(int sprindex) {
        if (get(sprindex, p_img) >= 0) {
    	    return png[get(sprindex, p_img)].getHeight() / get(sprindex, p_h);
        } else {
            return -1;
        }
    }

   public static int getrow(int sprindex) {
        return get(sprindex, p_row);
    }

    public static void setrow(int sprindex, int value) {
        set(sprindex, p_row, value);
    }

    public static int gettrans(int sprindex) {
        return get(sprindex, p_trans);
    }

    public static void settrans(int sprindex, int value) {
        if((value >= 0)&&(value < 8)) {
            set(sprindex, p_trans, value);
        }
    }

    public static int getimageindex(int sprindex) {
        return get(sprindex, p_img);
    }

    public static void setimageindex(int sprindex, int value) {
        if((value >= 0)&&(value <= curimg)) {
            set(sprindex, p_img, value);
        }
    }

    public static Image getimage(int sprindex) {
        int i = getimageindex(sprindex);
        if ((i >= 0)&&(i <= curimg)) {
            return png[i];
        } else return null;
    }

    public static void setimage(int sprindex, Image img) {
        if(getimageindex(sprindex) >= 0) {
            png[getimageindex(sprindex)] = img;
        }
    }

    public static int getenable(int sprindex) {
        return get(sprindex, p_enable);
    }

    public static void setenable(int sprindex, int value) {
        set(sprindex, p_enable, value);
    }

    public static void setvisible(int sprindex, int value) {
        set(sprindex, p_visible, value);
    }

    public static int getvisible(int sprindex) {
        return get(sprindex, p_visible);
    }

    public static int getframeback(int sprindex) {
        return get(sprindex, p_frameback);
    }

    public static void setframeback(int sprindex, int value) {
        set(sprindex, p_frameback, value);
    }
    
    //     
    public static void move(int sprindex, int x, int y) {
        setx(sprindex, x + getx(sprindex));
        sety(sprindex, y + gety(sprindex));
    }
    
    //    
    public static void moveto(int sprindex, int x, int y) {
        setx(sprindex, x);
        sety(sprindex, y);
    }
    
    //   (   step)
    public static void moveleft(int sprindex) {
        setx(sprindex, getx(sprindex) - getstep(sprindex));
    }
    
    //   (   step)
    public static void moveright(int sprindex) {
        setx(sprindex, getx(sprindex) + getstep(sprindex));
    }
    
    //   (   step)
    public static void moveup(int sprindex) {
        sety(sprindex, gety(sprindex) - getstep(sprindex));
    }
    
    //   (   step)
    public static void movedown(int sprindex) {
        sety(sprindex, gety(sprindex) + getstep(sprindex));
    }
    
    //     
    public static int addi(Image img) {
        if (curimg < sprcount - 1) {
            curimg++;
            png[curimg] = img;
            return curimg;
        } else return -1;
    }

    //  
    public static void prevframe(int sprindex) {
        if((sprindex >= 0)&&(sprindex <= curspr)) {
            int f = get(sprindex, p_frame);
            int fp = get(sprindex, p_fplus);
            if((f - fp >= getframes(sprindex))||(f - fp < 0)) {
            	if (getframeback(sprindex) == 0) {
            	    f = getframes(sprindex);
            	} else {
                    fp = -fp;
                    set(sprindex, p_fplus, fp);
                }
            }
            f -= fp;
            setframe(sprindex, f);
        }
    }
    
    //  
    public static void nextframe(int sprindex) {
        if((sprindex >= 0)&&(sprindex <= curspr)) {
            int f = getframe(sprindex);
            int fp = get(sprindex, p_fplus);
            if((f + fp >= getframes(sprindex))||(f + fp < 0)) {
            	if (getframeback(sprindex) == 0) {
            	    f = -1;
            	} else {
                    fp = -fp;
                    set(sprindex, p_fplus, fp);
                }
            }
            f += fp;
            setframe(sprindex, f);
        }
    }

    //  
    public static void prevrow(int sprindex) {
        if((sprindex >= 0)&&(sprindex <= curspr)) {
            int r = get(sprindex, p_row);
            int rp = get(sprindex, p_rplus);
            if((r - rp >= getrows(sprindex))||(r - rp < 0)) {
                rp = -rp;
                set(sprindex, p_rplus, rp);
            }
            r -= rp;
            setrow(sprindex, r);
        }
    }
    
    //  
    public static void nextrow(int sprindex) {
        if((sprindex >= 0)&&(sprindex <= curspr)) {
            int r = get(sprindex, p_row);
            int rp = get(sprindex, p_rplus);
            if((r + rp >= getrows(sprindex))||(r + rp < 0)) {
                rp = -rp;
            }
            r += rp;
            setrow(sprindex, r);
        }
    }

    //    (   )
    public static Image getframeimage(int sprindex) {
        Image res = empty();
        if((sprindex >= 0)&&(sprindex <= curspr)) {
            if((getvisible(sprindex) > 0)&&(getimageindex(sprindex) >= 0)) {
                int fromx = getframe(sprindex) * getw(sprindex);
                int fromy = getrow(sprindex) * geth(sprindex);
                res = Image.createImage(png[getimageindex(sprindex)],
                    fromx, fromy, getw(sprindex), geth(sprindex), gettrans(sprindex));
            }
        }
        return res;
    }
    
    //     
    //      
    public static int adds(int imgindex) {
        if ((curspr < sprcount - 1)&&(imgindex <= curimg)&&(imgindex >= 0)) {
            curspr++;
            p[curspr][p_img] = imgindex;
            p[curspr][p_visible] = 1;
            p[curspr][p_enable] = 1;
            p[curspr][p_step] = 1;
            p[curspr][p_fplus] = 1;
            p[curspr][p_rplus] = 1;
            int w = png[imgindex].getWidth();
            int h = png[imgindex].getHeight();
            if((w > 0)&&(h > 0)) {
                p[curspr][p_w] = w;
                p[curspr][p_h] = h;
            }
            return curspr;
        } else return -1;
    }

    //     
    //          
    public static int addswh(int imgindex, int w, int h) {
        if ((curspr < sprcount - 1)&&(imgindex <= curimg)&&(imgindex >= 0)) {
            curspr++;
            p[curspr][p_img] = imgindex;
            p[curspr][p_visible] = 1;
            p[curspr][p_enable] = 1;
            p[curspr][p_step] = 1;
            p[curspr][p_fplus] = 1;
            p[curspr][p_rplus] = 1;
            int ww = png[imgindex].getWidth();
            int hh = png[imgindex].getHeight();
            if((ww > 0)&&(hh > 0)&&(w <= ww)&&(h <= hh)) {
            	p[curspr][p_w] = w;
            	p[curspr][p_h] = h;
            } else {
            	p[curspr][p_w] = ww;
            	p[curspr][p_h] = hh;
            }
            return curspr;
        } else return -1;
    }

    //     
    //   
    public static int addis(Image img) {
        return adds(addi(img));
    }

    //     
    //       
    public static int addiswh(Image img, int w, int h) {
        return addswh(addi(img), w, h);
    }

    //       
    public static int addcopy(int sprindex) {
        int res = -1;
        if ((sprindex >= 0)&&(sprindex < sprcount)&&(curspr >= 0)&&(curspr < sprcount - 1)) {
            res = adds(getimageindex(sprindex));
            for(int i = 0; i < parcount; i++) {
                p[res][i] = p[sprindex][i];
            }
        }
        return res;
    }

    //    
    public static int getx0(int sprindex) {
        int x = getx(sprindex) - getw(sprindex) / 2;
        if ((getalign(sprindex) == 1)||(getalign(sprindex) == 2)||(getalign(sprindex) == 8)) {
            x = getx(sprindex) - getw(sprindex);
        }
        if ((getalign(sprindex) == 4)||(getalign(sprindex) == 5)||(getalign(sprindex) == 6)) {
            x = getx(sprindex);
        }
        return x;
    }

    //    
    public static int gety0(int sprindex) {
        int y = gety(sprindex) - geth(sprindex) / 2;
        if ((getalign(sprindex) == 1)||(getalign(sprindex) == 2)||(getalign(sprindex) == 8)) {
            y = gety(sprindex) - geth(sprindex);
        }
        if ((getalign(sprindex) == 4)||(getalign(sprindex) == 5)||(getalign(sprindex) == 6)) {
            y = gety(sprindex);
        }
        return y;
    }


    //    
    // ( visible != 0        )
    public static void drawspr(int sprindex) {
        if((sprindex >= 0)&&(sprindex <= curspr)) {
            if((getvisible(sprindex) > 0)&&(getimageindex(sprindex) >= 0)) {
                if(xrect(getx0(sprindex), gety0(sprindex),
                        getw(sprindex), geth(sprindex), 0, 0,
                        M.I.getWidth(), M.I.getHeight()) > 0) {
                    int w = getw(sprindex);
                    int h = geth(sprindex);
                    int fromx = getframe(sprindex) * w;
                    int fromy = getrow(sprindex) * h;
                    M.G.drawRegion(png[getimageindex(sprindex)], fromx, fromy,
                            w, h, gettrans(sprindex),
                            getx0(sprindex), gety0(sprindex), M.G.TOP | M.G.LEFT);
                }
            }
        }
    }

    //      (   layer)
    public static void drawall() {
        for(int il = 0; il <= curspr; il++) {
            for(int is = 0; is <= curspr; is++) {
                if (getlayer(is) == il) {
                    drawspr(is);
                }
            }
        }
    }
    
    //  
    // ( )
    public static int overrect(int spr1, int spr2) {
        int res = xrect(getx0(spr1), gety0(spr1), getw(spr1), geth(spr1), getx0(spr2), gety0(spr2), getw(spr2), geth(spr2));
        res = (getenable(spr1) == 0) ? 0 : res;
        res = (getenable(spr2) == 0) ? 0 : res;
        return res;
    }
    
    //  
    public static int overpix(int spr1, int spr2) {
        int res = 0;
        //   ,  
        if (overrect(spr1, spr2) > 0) {
            //    
            int[] rx = new int[4];
            int[] ry = new int[4];
            rx[0] = getx0(spr1);
            rx[1] = getx0(spr2);
            rx[2] = getx0(spr1) + getw(spr1) - 1;
            rx[3] = getx0(spr2) + getw(spr2) - 1;
            ry[0] = gety0(spr1);
            ry[1] = gety0(spr2);
            ry[2] = gety0(spr1) + geth(spr1) - 1;
            ry[3] = gety0(spr2) + geth(spr2) - 1;
            //    
            int tmp = 0;
            boolean need = true;
            while(need) {
                need = false;
                for(int i = 0; i < 3; i++) {
                    if(rx[i] > rx[i + 1]) {
                        need = true;
                        tmp = rx[i];
                        rx[i] = rx[i + 1];
                        rx[i + 1] = tmp;
                    }
                    if(ry[i] > ry[i + 1]) {
                        need = true;
                        tmp = ry[i];
                        ry[i] = ry[i + 1];
                        ry[i + 1] = tmp;
                    }
                }
            }
            // ,    -      
            //    /  
            int w = rx[2] - rx[1] + 1;
            int h = ry[2] - ry[1] + 1;
            int xx = rx[1];
            int yy = ry[1];
            rx = null;
            ry = null;
            //    
            // ,      
            int x1 = (getx0(spr1) < xx) ? xx - getx0(spr1) : 0;
            int y1 = (gety0(spr1) < yy) ? yy - gety0(spr1) : 0;
            int x2 = (getx0(spr2) < xx) ? xx - getx0(spr2) : 0;
            int y2 = (gety0(spr2) < yy) ? yy - gety0(spr2) : 0;
            //     -   cldc,  
            //  :
            w = (x1 + w > getw(spr1)) ? getw(spr1) - x1 : w;
            h = (y1 + h > geth(spr1)) ? geth(spr1) - y1 : h;
            w = (x2 + w > getw(spr2)) ? getw(spr2) - x2 : w;
            h = (y2 + h > geth(spr2)) ? geth(spr2) - y2 : h;
            int l = w * h;
            //   ...
            if ((getimageindex(spr1) >= 0)&&(getimageindex(spr2) >= 0)&&(w > 0)&&(h > 0)) {
                int[] bmp1 = new int[l];
                int[] bmp2 = new int[l];
                //        - 
                getframeimage(spr1).getRGB(bmp1, 0, w, x1, y1, w, h);
                getframeimage(spr2).getRGB(bmp2, 0, w, x2, y2, w, h);
                boolean ok = false;
                int i = 0;
                while ((i < l)&&(!ok)) {
                    ok = (((bmp1[i] & 0xff000000) >> 24) >= Fminalpha)&&(((bmp2[i] & 0xff000000) >> 24) >= Fminalpha);
                    i++;
                }
                if (ok) {
                    res = 1;
                }
                bmp1 = null;
                bmp2 = null;
            }
        }
        return res;
    }
    
    //    
    //      1 
    //   -   
    public static int dels(int sprindex) {
        if ((sprindex <= curspr)&&(sprindex >= 0)) {
            for(int is = sprindex; is < curspr; is++) {
                for(int ip = 0; ip < parcount; ip++) {
                    p[is][ip] = p[is + 1][ip];
                }
            }
            curspr--;
            return curspr;
        } else return -1;
    }
    
    //    
    //      1 
    //   -   
    public static int deli(int imgindex) {
        if ((imgindex <= curimg)&&(imgindex >= 0)) {
            for(int ip = 0; ip < curimg; ip++) {
            	png[ip] = null;
                png[ip] = png[ip + 1];
            }
            png[curimg] = null;
            curimg--;
            return curimg;
        } else return -1;
    }
    
}